const prefersDarkScheme = window.matchMedia("(prefers-color-scheme: dark)");
const themeStorageKey = "quoll-theme";
const localStorageTheme = localStorage.getItem(themeStorageKey);
const darkThemeClassName = "dark-theme";
const lightThemeName = "Ada";
const darkThemeName = "Ada After Dark";

$(function (){
    $(".darkModeToggleButton").on("click", function(event) {
        $("body").toggleClass(darkThemeClassName);
        saveTheme();
    });
    
    $(".hideHeaderButton").on("click", function(event) {
        $("header").hide(200, function() {
            $(".showHeaderButton").show(200);
            $("main > h1:first-child").addClass("compressed");
            $(".status-line-container").addClass("no-header");
        })});

    $(".showHeaderButton").on("click", function(event) {
        $(".showHeaderButton").hide(200, function() {
            $("header").show(200)
            $("main > h1:first-child").removeClass("compressed");
            $(".status-line-container").removeClass("no-header");
        })});

    $(".showHeaderButton").hide();

    if ($(".devDiaryAuthor").length && $(".footnotes").length)
    {
        $(".footnotes").insertAfter(".devDiaryAuthor");
    }

    // Fix up anchor links
    let pathname = window.location.href.split('#')[0];
    $('a[href^="#"]').each(function() {
        let link = $(this).attr('href');
        $(this).attr('href', pathname + link);
    });

    if (localStorageTheme == null)
    {
        if (prefersDarkScheme.matches) {
            $("body").addClass(darkThemeClassName);
        } else {
            $("body").removeClass(darkThemeClassName);
        }
        saveTheme();
    }
    else if (localStorageTheme == darkThemeName) {
        $("body").addClass(darkThemeClassName);
    }

    hljs.registerAliases("inform6", {languageName: "c"})
    hljs.registerAliases("sgl", {languageName: "plaintext"})
    hljs.highlightAll();

    function saveTheme() {
        let darkThemeClassSet = $("body").hasClass(darkThemeClassName);
        let theme = darkThemeClassSet ? darkThemeName : lightThemeName;
        localStorage.setItem(themeStorageKey, theme);
    }
});